<!--
This file is part of pybib2web, a translator of BibTeX to HTML.
https://gitlab.com/sosy-lab/software/pybib2web

SPDX-FileCopyrightText: 2021 Dirk Beyer <https://www.sosy-lab.org>

SPDX-License-Identifier: Apache-2.0
-->

# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [0.6]

### Added

- BibTeX entries are now numbered across categories.
  Before, each category's entries were numbered starting with 1.
  If multiple categories (publication types, years) are displayed on a single page, the entries are still numbered continuously.

### Fixed

- LaTeX commands in BibTex entries' titles are now detexified correctly. These commands were incorrectly removed before.
  This turned a title like "\textsc{CPAchecker}: [...]" into ": [...]"

## [0.5.1]

### Fixed

- Escape the raw BibTex output of entries so that it renders as the original, valid BibTeX.	
  Before, HTML links in the BibTex annote field were rendered, so the links could not be copied with the remaining BibTex-entry content.

## [0.5]

### Added

- Support [arXiv DOIs](https://blog.arxiv.org/2022/02/17/new-arxiv-articles-are-now-automatically-assigned-dois/)

## [0.4.3]

### Changed

- Fix crash in htmlexport.
  Before, pybib2web crashed if there was a  BibTeX entry
  with at least one, but not all of the following properties:
	* technical report with key 'number'
	* key 'venue'
	* key 'howpublished'
	* key 'institution'

## [0.4.2]

### Added

- Support new BibTeX value `urlpub` to link to any publisher's version.
  It is still recommended to use the `doi` or `urn`, if available.
  The `urlpub` will only be linked as publisher's version if none of the latter is available.
  Example BibTeX:

  ```
  @inproceedings{ExampleEntry,
    author    = {D.~Beyer and M.~Dangl and D.~Dietsch and M.~Heizmann},
    title     = {Exchanging Verification Witnesses between Verifiers},
    booktitle = {Proc. SE},
    publisher = {GI},
    year      = {2017},
    urlpub    = {https://dl.gi.de/handle/20.500.12116/1288},
  }
  ```
- Add CSS class `publishers-version-link`. Links to DOI, URN and urlpub are members of this class.
  This allows for uniform styling of the three different types of publisher's versions.
  To be more precise, DOI links can still be targeted with CSS class `doi-link`, the URN link with
  CSS class `urn-link`. Example CSS:

  ```css
  .publishers-version-link { /* styling for _all_ links to publishers version */ }
  .doi-link { /* styling for all DOI links */ }
  .urn-link { /* styling for all URN links */ }
  ```

### Changed

- Variable '{timestamp}' in the HTML tail now contains the timezone. For an example usage, see [`doc/config.yml`](doc/config.yml)

## [0.4.1]

### Changed

- If `--singlepage` is used, no internal links are created. Before, only links to author pages were not created,
	but (invalid) links to funding and keywords were. Now, no links are created anymore.
- BibTeX entries on webpage show "abstract" and "keyword" always last.
	Before, these two entries were at the position defined in the original BibTeX entry.

## [0.4]

### Added

- Command-line option `--singlepage` allows to create a single HTML page, similar to `All/index.html`,
	instead of the full HTML directory structure.
	If `--singlepage` is used, the HTML is always written to stdout and `--output` is ignored.

### Changed

- Superfluous whitespace and linebreaks in the HTML that were rendered as spaces are removed now.
  	For example, the list of authors said ",  and", with two spaces.
	It now correctly says ", and".
    

## [0.3]

### Added

- First names and last names of authors are now accessible individually:
	First names and last names of authors and editors in the bibliography index and
	in bibliography list items are now wrapped by `span` elements
	and can be accessed through classes `.firstname` and `.lastname`.

	Created HTML will look like this:

	```
	<span class="firstname">John</span><span class="lastname">Doe</span>
	```
- pybib2web now supports author indexing for authors without either first or last name. For example,
	name "Doe" is now handled well.

- pybib2web now fully hides empty categories ('authors,', 'keywords', 'funding', etc.) on the index page.
	Before, the category header was displayed without any entries, which used up unnecessary space
	and could have been confusing.

- pybib2web now includes a footer on every generated HTML page, that displays the following text:
	"This file was generated by pybib2web, version x.x"
	The footer can be accessed through HTML id `#generator`.

### Changed

- The header of the index page does not talk about 'bibliography' anymore,
	but uses the given title ('publications', by default).
	This tailors the page text stronger to the use case.
	For example, if `--title Talks` is used, the index page will
	say "Complete list of talks" instead of "Complete list of publications".

- In first names, shortening now respects hyphens (John-Jane Doe) and apostrophes (J'Jane Doe).
	Before, both above examples were turned into "J. Doe".
	The result now would be "J.-J. Doe" and "J'J. Doe", respectively.

- Reduced dependency on bibtexparser from version 1.2 to 1.1
	This version is available in the package repository
	of Ubuntu 20.04, so let's be nice and show users
	that this is usable.

## [0.2]

### Added

- pybib2web now supports the uniform resource name ([URN](https://en.wikipedia.org/wiki/Uniform_Resource_Name))
	as unique identifier for resources, as alternative to the DOI. If no DOI is available for a BibTeX entry
	but a URN is, the URN will be used to provide a link to the entry's publisher version.

### Removed

- Script `contrib/check-doi` has been removed to ease maintenance and distribution of pybib2web.
  It is only used internally at [SoSy-Lab](https://www.sosy-lab.org/).



## [0.1]

### Added

- Base version of pybib2web: Parse .bib BibTeX files and output HTML. This tries
	to mimic the overall behavior of [bibtex2html](https://sourceforge.net/projects/bibtex2html/), but uses more structured HTML (e.g., more classes and ids for manual CSS layouting).
- Script `contrib/check-doi` for checking the DOIs of BibTeX entries. check-doi makes sure
	that DOIs listed in .bib BibTeX files are available online, and downloads
	all available metadata through https://www.crossref.org/.


[Unreleased]: https://gitlab.com/sosy-lab/software/pybib2web/-/compare/0.6...HEAD
[0.1]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.1
[0.2]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.2
[0.3]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.3
[0.4]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.4
[0.4.1]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.4.1
[0.4.2]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.4.2
[0.4.3]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.4.3
[0.5]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.5
[0.5.1]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.5.1
[0.6]: https://gitlab.com/sosy-lab/software/pybib2web/-/releases/0.6
